
static Widget creer_label(char *nom, Widget pere)
{
  return(XtVaCreateManagedWidget(nom, xmLabelWidgetClass, pere,
				 XmNlabelString, XmStringCreateLtoR(nom, 
								    XmSTRING_DEFAULT_CHARSET), 
				 XmNwidth, LABEL_WIDTH, XmNheight, BUTTON_HEIGHT, NULL));
}


static Widget creer_bouton(char *nom, Widget pere, int bordWidth)
{
  return(XtVaCreateManagedWidget(nom, xmPushButtonWidgetClass, pere, XmNwidth, BUTTON_WIDTH,
				 XmNborderWidth, bordWidth, XmNlabelString, 
				XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET), NULL));
}

static Widget creer_jauge(char *nom, Widget pere, int min, int max)
{
  return(XtVaCreateManagedWidget(nom, xmScaleWidgetClass, pere, XmNtitleString, 
				 XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET),
				 XmNminimum, min, XmNmaximum, max, XmNshowValue, true, 
				 XmNorientation, XmHORIZONTAL, XmNscaleHeight, 40, 
				 XmNscaleWidth, 200, NULL));
}


static void creation_pace_rhythm(Widget w)
{
  Widget     t_widg, widg1, widg2, widg3, widg4, canvas_widg;

  canvas_widg = XtVaCreateManagedWidget("meter_pace", xmDrawingAreaWidgetClass, w, 
					XmNborderWidth, 0, XmNwidth, 180, XmNheight, 25 /*45 */, 
					XmNtopAttachment, XmATTACH_FORM, 
					XmNbottomAttachment, XmATTACH_FORM, NULL);
  meter_pace_creat(canvas_widg);
  widg1 = creer_bouton("+", w, 2);
  XtVaSetValues(widg1,  XmNheight, BUTTON_HEIGHT_PACE, XmNtopAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, canvas_widg, NULL);
  XtAddCallback(widg1, XmNactivateCallback, inter_pace_up_p, NULL);
  widg2 = creer_bouton("-", w, 2);
  XtAddCallback(widg2, XmNactivateCallback, inter_auto, NULL);
  XtVaSetValues(widg2,  XmNheight, BUTTON_HEIGHT_PACE, XmNtopAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		  XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, widg1, NULL);
  XtAddCallback(widg2, XmNactivateCallback, inter_pace_down_p, NULL);
  widg3 = creer_bouton("/", w, 2);
  XtVaSetValues(widg3,  XmNheight, BUTTON_HEIGHT_PACE , XmNtopAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, widg2 , NULL);
  XtAddCallback(widg3, XmNactivateCallback,  inter_pace_down_m, NULL);
  widg4 = creer_bouton("*", w, 2);
  XtVaSetValues(widg4,  XmNheight, BUTTON_HEIGHT_PACE, XmNtopAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, widg3 , NULL);
  XtAddCallback(widg4, XmNactivateCallback,  inter_pace_up_m, NULL);
}


static void creation_pace_control(Widget w)
{
  Widget     t_widg, widg;

  t_widg = creer_bouton("TICK", w, 2);
  XtVaSetValues(t_widg,  XmNheight, BUTTON_HEIGHT_C, XmNtopAttachment, XmATTACH_FORM,
		XmNrightAttachment, XmATTACH_FORM, NULL);
  XtAddCallback(t_widg, XmNactivateCallback, inter_tick, NULL);
  widg = creer_bouton("AUTO", w, 2);
  XtVaSetValues(widg,  XmNheight, BUTTON_HEIGHT_C, XmNtopAttachment, XmATTACH_FORM,
		XmNrightAttachment, XmATTACH_WIDGET, XmNrightWidget, t_widg, NULL);
  XtAddCallback(widg, XmNactivateCallback, inter_auto, NULL);
  auto_creat(widg);
  widg = creer_bouton("QUIT", w, 2);
  XtVaSetValues(widg,  XmNheight, BUTTON_HEIGHT_C, XmNtopAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM, NULL);
  XtAddCallback(widg, XmNactivateCallback, inter_stop, NULL);
  stop_creat(widg);
}


static void creation_pace_maker(Widget w)
{
  Widget  control_widg, rhythm_widg;

  rhythm_widg = XtVaCreateManagedWidget("pace_rhythm", xmFormWidgetClass, w, 
					XmNborderWidth, 1,
					XmNtopAttachment, XmATTACH_FORM, 
					XmNrightAttachment, XmATTACH_FORM,
					XmNleftAttachment, XmATTACH_FORM,
					NULL);
  creation_pace_rhythm(rhythm_widg);
  control_widg = XtVaCreateManagedWidget("pace_control", xmFormWidgetClass, w, 
					 XmNrightAttachment, XmATTACH_FORM,
					 XmNleftAttachment, XmATTACH_FORM,
					 XmNtopAttachment, XmATTACH_WIDGET,
					 XmNtopWidget, rhythm_widg,
					 NULL);
  creation_pace_control(control_widg);
}

#define  MIN_A 0
#define  MAX_A 60


static void creation_panel_gauche(Widget pere)
{
  Widget    w1, w2, w3, w4, w5, w6, panel_clock_Y, panel_clock_A;

 
  // w1 = creer_bouton("START", pere, 1);
  // XtAddCallback(w1, XmNactivateCallback, (XtCallbackProc)inter_OK_Y, NULL);
  w1 = creer_label("START", pere);
  XtVaSetValues(w1,  XmNheight, BUTTON_HEIGHT, XmNtopAttachment, XmATTACH_FORM,
		XmNleftAttachment,  XmATTACH_FORM, XmNrightAttachment,  XmATTACH_FORM, NULL);

  w2 = creer_bouton("CLICK", pere, 1);
  XtVaSetValues(w2,  XmNheight, BUTTON_HEIGHT, 
		XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w1,
		XmNleftAttachment,  XmATTACH_FORM, XmNrightAttachment,  XmATTACH_FORM,
		NULL);
  XtAddCallback(w2, XmNactivateCallback, (XtCallbackProc)inter_CLICK, NULL);


  w3 = creer_label("TICK", pere);
  XtVaSetValues(w3, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w2, NULL);

  w4 = creer_label("RELAX", pere);
  XtVaSetValues(w4, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w3, NULL);

  w5 = creer_label("SINGLE", pere);
  XtVaSetValues(w5, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w4, NULL);

  w6 = creer_label("DOUBLE", pere);
  XtVaSetValues(w6, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w5, XmNbottomAttachment, XmATTACH_FORM, NULL);

}


//   static void creation_input_panel(Widget pere)
// {
//   Widget panel_scale_widg, w1, w2, w3;

//   panel_scale_widg = XtVaCreateManagedWidget("panel_scale", xmFormWidgetClass, pere, 
// 					     /*XmNborderWidth, 1, */
// 					     XmNhorizontalSpacing, 50,
// 					     XmNverticalSpacing, 10,
// 					     XmNleftAttachment,  XmATTACH_FORM,
// 					     XmNtopAttachment, XmATTACH_FORM, NULL);

//   w1 = creer_jauge("A          ",panel_scale_widg, MIN_A, MAX_A);
//   XtVaSetValues(w1, XmNtopAttachment, XmATTACH_FORM, XmNleftAttachment, XmATTACH_FORM, NULL);
//   XtAddCallback(w1, XmNdragCallback, (XtCallbackProc)inter_A, NULL);

// }


static void creation_id(Widget w)
{
  Widget panel_cadre, panel_gauche_widg, widg, panel_input_widg;

  panel_cadre = XtVaCreateManagedWidget("panel_cadre", xmFormWidgetClass, w, 
					XmNtopAttachment, XmATTACH_FORM, 
					XmNverticalSpacing, ESP_HEIGHT, NULL);
  
  panel_gauche_widg = XtVaCreateManagedWidget("panel_gauche", xmFormWidgetClass, panel_cadre,
					      XmNborderWidth, 1,
					      XmNtopAttachment, XmATTACH_FORM,
					      XmNbottomAttachment,  XmATTACH_FORM,
					      XmNverticalSpacing, ESP_HEIGHT, NULL);
  creation_panel_gauche(panel_gauche_widg);
  widg = XtVaCreateManagedWidget("canvas", xmDrawingAreaWidgetClass, panel_cadre, 
				 XmNborderWidth, 1, XmNwidth, CANVAS_WIDTH, 
				 XmNheight, CANVAS_HEIGHT, XmNtopAttachment, XmATTACH_FORM,
				 XmNbottomAttachment,  XmATTACH_FORM,
				 XmNleftAttachment, XmATTACH_WIDGET, 
				 XmNleftWidget, panel_gauche_widg, NULL);
  canvas_creat(widg);
  panel_input_widg =  XtVaCreateManagedWidget("panel_input", xmFormWidgetClass, w, 
					      XmNtopAttachment,  XmATTACH_WIDGET, 
					      XmNtopWidget, panel_cadre,
					      XmNleftAttachment,  XmATTACH_FORM,
					      /* XmNhorizontalSpacing, ESP_HEIGHT, */
					      NULL);
  //  creation_input_panel(panel_input_widg);
}

/*------------------------------------------------------------------------------
  Creating the main window.
 ------------------------------------------------------------------------------*/
static void mk_main_window(Widget toplevel)
{
  Widget pace_maker_widg, appli_widg, cadre_widg, frame_widg;

  cadre_widg = XtVaCreateManagedWidget("cadre", xmMainWindowWidgetClass, toplevel, NULL);
  frame_widg = XtVaCreateManagedWidget("frame", xmFormWidgetClass, cadre_widg, NULL);
  appli_widg = XtVaCreateManagedWidget(PROGNAME, xmFormWidgetClass, frame_widg, 
				      XmNtopAttachment,  XmATTACH_FORM, 
				      XmNleftAttachment, XmATTACH_FORM, 
				      XmNrightAttachment, XmATTACH_FORM, NULL);
  creation_id(appli_widg);

  pace_maker_widg = XtVaCreateManagedWidget("pace_maker", xmFormWidgetClass, frame_widg, 
					    XmNleftAttachment, XmATTACH_FORM, 
					    XmNtopAttachment, XmATTACH_WIDGET, 
					    XmNtopWidget, appli_widg, 
					    XmNbottomAttachment, XmATTACH_FORM, NULL);
  creation_pace_maker(pace_maker_widg);
}
