/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#include <semaphore.h>

// A Semaphore
// -----------

#define pK_sem_type \
  sem_t

#define pK_sem_dcl(s) \
  pK_sem_type s;

#define pK_sem_ini(s, vini)		    \
  if (sem_init(&s, 0, (unsigned) vini) !=0) \
    { printf("Sem_ini error...\n"); exit(EXIT_FAILURE);}

/* attention : s est un pointeur
  #define pK_sem_ini(s, vini)			     \
  s = sem_open("/#s", O_CREAT, 0644, (unsigned) vini); \
  if ( s == SEM_FAILED) printf("Sem_ini error: \n");
*/

#define pK_sem_wait(s) \
  sem_wait(&s);

#define pK_sem_signal(s) \
  sem_post(&s);


// Array of Semaphores.
// -------------------

#define pK_sem_dcl_array(N) \
  pK_sem_type semTable[N];

#define pK_Isem_ini(numSem, vini) \
  if (sem_init(&semTable[numSem], 0, (unsigned) vini) !=0) \
    { printf("Sem_ini error: <%d>\n", numSem); exit(EXIT_FAILURE);}

#define pK_Isem_wait(numSem) \
  sem_wait(&semTable[numSem]);

#define pK_Isem_signal(numSem) \
  sem_post(&semTable[numSem]);


